力扣刷题练习八【922. 按奇偶排序数组II】

前言

数组题目练习。

练习题八 【922. 按奇偶排序数组II】


一、题目阅读

给定一个非负整数数组 nums, nums 中一半整数是 奇数 ,一半整数是 偶数 。

对数组进行排序,以便当 numsi 为奇数时,i 也是 奇数 ;当 numsi 为偶数时, i 也是 偶数 。

你可以返回 任何满足上述条件的数组作为答案 。

示例 1:

复制代码
输入:nums = [4,2,5,7]
输出:[4,5,2,7]
解释:[4,7,2,5],[2,5,4,7],[2,7,4,5] 也会被接受。

示例 2:

复制代码
输入:nums = [2,3]
输出:[2,3]

提示:

复制代码
2 <= nums.length <= 2 * 104
nums.length 是偶数
nums 中一半是偶数
0 <= nums[i] <= 1000

进阶:可以不使用额外空间解决问题吗?


二、尝试实现

思路

  • 理解题目:长度肯定是偶数,因为说nums内元素一半奇数,一半偶数。说明如果i为奇数,numsi是偶数,肯定有个地方j是偶数,numsj是奇数。所以这成对出现,就可以在原数组里面找到交换的对象。给了在原数组上操作思路。
  • i只指向奇数下标,如果numsi也是奇数,i +=2k;继续往下。
  • i只指向奇数下标,如果numsi是偶数。用j指向偶数下标,while循环找numsj是奇数。找到之后交换。

代码实现

cpp 复制代码
class Solution {
public:
    vector<int> sortArrayByParityII(vector<int>& nums) {
        int j=0;
        for(int i = 1 ;i < nums.size();i +=2){
            if(nums[i]%2 == 0){
                while(j < nums.size() && (nums[j]%2 == 0)){
                    j += 2;
                }
                swap(nums[i],nums[j]);
            }
        }
        return nums;
    }
};

三、参考答案

参考答案链接

学习内容

给了三种方法:

第三种方法最简洁和尝试实现中的思路一致,只不过奇偶换一下。思路里的成对出现,很能够简单解决,也不用额外记录谁换过谁没换过。


总结

如果一个奇数位对应偶数,那么肯定一个偶数位对应奇数。

(欢迎指正,转载标明出处)

相关推荐
fpcc5 小时前
c++编程实践—堆和栈越界调试
c++
yi0115 小时前
LeetCode 219:存在重复元素 II——哈希表记录“最近一次出现的位置”
数据结构·人工智能·笔记·python·算法·leetcode·哈希表
YangYang9YangYan6 小时前
2027 秋招|数据科学与大数据技术面试项目价值回答思路,告别纯代码描述
大数据·面试·职场和发展
weiabc7 小时前
MSYS2 UCRT64 + g++ C++ 中文输出乱码 完整全过程
c++
灯澜忆梦8 小时前
【面向对象编程C++】| 基础语法
java·c++·算法
禾小西8 小时前
Redis 数据结构:快速的 Redis 有哪些慢操作?
数据结构·数据库·redis
小蒋观天下8 小时前
专项方案:大场景港口AI安防、多干扰环境下的算法调优与落地实操
人工智能·深度学习·算法·安全·机器学习·计算机视觉·ai大模型
Evand J8 小时前
【电机滤波例程5】渐消因子自适应扩展卡尔曼滤波(EKF),MATLAB。PMSM负载突变下的状态估计。附下载链接
算法·matlab
H.莓飛8 小时前
【数据结构】二叉树_OJ题
linux·开发语言·数据结构·算法
好想像大佬一样能够ak所有9 小时前
Leetcode35.搜索插入位置
数据结构·算法·leetcode